# coding: Shift_JIS

import os
import Image
import struct

# ---------------------------------------------------------------------------

def Img2bin(file, lz77):
	
	if os.access(file, os.F_OK) == False:
		return
	
	print 'img2bin ... ' + file
	p = Image.open(file)
	iw, ih = p.size
	
	if (lz77 == 0):
		os.system('..\\exe\\dec\\grit.exe ' + file + ' -gb -gB16 -ftb -gu16 -gz! -fh!')
	else:
		os.system('..\\exe\\dec\\grit.exe ' + file + ' -gb -gB16 -ftb -gu16 -gzl -fh!')
	
	f = open(file[:-4] + ".img.bin", "rb")
	x = f.read()
	f.close()
	
	f = open(file[:-4] + ".img.bin", 'wb')
	f.write(struct.pack('HHHH', iw, ih, lz77, 0))
	f.write(x);
	f.close()

# ---------------------------------------------------------------------------

def Colchg(name):
	
	print 'color change ... ' + name
	
	f = open(name, 'rb')
	x = f.read()
	f.close()
	
	f = open(name, 'wb')
	
	for j in range(len(x)):
		if (j == 1066):
			f.write(struct.pack('B', 6))	# B
		elif (j == 1067):
			f.write(struct.pack('B', 6))	# G
		elif (j == 1068):
			f.write(struct.pack('B', 6))	# R
		else:
			f.write(x[j])
	f.close()

# ---------------------------------------------------------------------------

def Resize(file):
	cmd  = ''
	
	if os.access(file, os.F_OK) == False:
		return
	
	print 'resize ... ' + file
	
	p = Image.open(file)
	iw, ih = p.size
	
	if (iw >= 640) and (ih >= 480):
		cmd = "..\\exe\\dec\\convert.exe -resize 240x160! ";
	else:
		iw  = int(iw * 0.375)
		ih  = int(ih * 0.334)
		if(iw % 2 != 0): iw -= 1
		if(ih % 2 != 0): ih -= 1
		cmd = "..\\exe\\dec\\convert.exe -resize %dx%d! " % (iw, ih)
	
	os.system(cmd + file + " " + file)
#	print cmd + file


# ---------------------------------------------------------------------------

path = os.getcwd()
dir  = os.listdir(path)
bmp = [i for i in dir if i.find('.bmp') != -1]
jpg = [i for i in dir if i.find('.jpg') != -1]


for i in range(len(bmp)):
	Colchg(bmp[i])


for i in range(len(bmp)):
	Resize(bmp[i])
for i in range(len(jpg)):
	Resize(jpg[i])


for i in range(len(bmp)):
	Img2bin(bmp[i], 1)
for i in range(len(jpg)):
	Img2bin(jpg[i], 1)


