#ifndef __SIORI_H__
#define __SIORI_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define SIORI_MAX_CNT				8
#define SIORI_SRAM_SIZE				0x8000

//---------------------------------------------------------------------------

typedef struct {
	u32 size;
} ST_SIORI;



//---------------------------------------------------------------------------
EWRAM_CODE void  SioriInit(void);
EWRAM_CODE void  SioriSave(u32 no);
EWRAM_CODE bool  SioriLoad(u32 no);

EWRAM_CODE char* SioriGetName(u32 no);
EWRAM_CODE bool  SioriIsSram(u32 no);


#ifdef __cplusplus
}
#endif
#endif
