#include <stdio.h>
#include <string.h>
#include "onejpg.h"


//---------------------------------------------------------------------------
const char* FileList[] = {
	"BG000",
	"BG010A",
	"BG010B",
	"BG010N",
	"BG010R",
	"BG020",
	"BG026",
	"BG027",
	"BG028",
	"BG030",
	"BG030B",
	"BG030N",
	"BG030NR",
	"BG030R",
	"BG030Y",
	"BG040",
	"BG040N",
	"BG040Y",
	"BG050",
	"BG050N",
	"BG060",
	"BG060N",
	"BG060R",
	"BG060Y",
	"BG070",
	"BG070N",
	"BG080",
	"BG080N",
	"BG080Y",
	"BG090",
	"BG090N",
	"BG100",
	"BG100N",
	"BG110",
	"BG110N",
	"BG120",
	"BG120A",
	"BG120N",
	"BG120Y",
	"BG130",
	"BG130A",
	"BG130N",
	"BG130R",
	"BG130Y",
	"BG140",
	"BG140N",
	"BG150",
	"BG160",
	"BG160A",
	"BG160N",
	"BG160R",
	"BG170",
	"BG170A",
	"BG170R",
	"BG170Y",
	"BG180",
	"BG180A",
	"BG180B",
	"BG190",
	"BG200",
	"BG200B",
	"BG200C",
	"BG200D",
	"BG210",
	"BG210B",
	"BG220",
	"BG220N",
	"BG220R",
	"BG220Y",
	"BG230",
	"BG230Y",
	"BG240",
	"BG240B",
	"BG250",
	"BG270",
	"BG270N",
	"BG280",
	"BG290",
	"BG300",
	"BG300Y",
	"BG310",
	"BG320",
	"BG330",
	"BG500",
	"BG501",
	"BG502",
	"BG503",
	"BG504",
	"BG505",
	"BG506",
	"BG507",
	"BG508",
	"BG510",
	"BG800",
	"BG801",
	"BG802",
	"BG803",
	"BG804",
	"BG805",
	"BG806",
	"BG807",
	"BG808",
	"BG809",
	"BG810",
	"BG811",
	"BG812",
	"BG813",
	"BG850",
	"BG851",
	"BG852",
	"BG853",
	"BG854",
	"BG855",
	"BG856",
	"BG857",
	"BG858",
	"BG859",
	"BG860",
	"BG861",
	"BG862",
	"BG863",
	"BG864",
	"BG865",
	"BG866",
	"BG867",
	"BG868",
	"BG869",
	"BG870",
	"BG871",
	"BG872",
	"BG873",
	"BG874",
	"BG875",
	"BG900",
	"FGAK01",
	"FGAK02C",
	"FGAK02D",
	"FGAK02F",
	"FGAK02G",
	"FGAK03",
	"FGAK04",
	"FGAK05A",
	"FGAK05B",
	"FGAK05C",
	"FGAK05D",
	"FGAK05E",
	"FGAK05F",
	"FGAK06",
	"FGAK07",
	"FGAK08",
	"FGAK09",
	"FGAK10",
	"FGAK11",
	"FGAK12",
	"FGAK13",
	"FGAK14",
	"FGAK15",
	"FGAK16",
	"FGMI01",
	"FGMI02",
	"FGMI03",
	"FGMI04",
	"FGMI05",
	"FGMI06",
	"FGMI07A",
	"FGMI07B",
	"FGMI07C",
	"FGMI08",
	"FGMI09",
	"FGMI10A",
	"FGMI10B",
	"FGMI11",
	"FGMI12",
	"FGMI13",
	"FGMI14A",
	"FGMI14B",
	"FGMI15",
	"FGMI16",
	"FGMS01",
	"FGMS02",
	"FGMS03",
	"FGMS04A",
	"FGMS04B",
	"FGMS05A",
	"FGMS05B",
	"FGMS06",
	"FGMS07",
	"FGMS08",
	"FGMS09",
	"FGMS10",
	"FGMS11A",
	"FGMS11B",
	"FGMS12",
	"FGMS13",
	"FGMS14",
	"FGMS15A",
	"FGMS15B",
	"FGMS16",
	"FGMS17",
	"FGMY01",
	"FGMY03A",
	"FGMY03B",
	"FGMY03C",
	"FGMY04",
	"FGMY05",
	"FGMY06",
	"FGMY07",
	"FGMY08",
	"FGMY09",
	"FGMY11",
	"FGMY12",
	"FGMY13",
	"FGMY14",
	"FGMY15A",
	"FGMY15B",
	"FGMY15C",
	"FGMZ01",
	"FGMZ02",
	"FGMZ03",
	"FGMZ04",
	"FGMZ05A",
	"FGMZ05B",
	"FGMZ06A",
	"FGMZ06B",
	"FGMZ07",
	"FGMZ08",
	"FGMZ09A",
	"FGMZ09B",
	"FGMZ10",
	"FGMZ11",
	"FGMZ12",
	"FGMZ13",
	"FGMZ14",
	"FGMZ15",
	"FGMZ16",
	"FGRM01",
	"FGRM02A",
	"FGRM02B",
	"FGRM02E",
	"FGRM02G",
	"FGRM02GN",
	"FGRM02H",
	"FGRM02V",
	"FGRM03A",
	"FGRM03B",
	"FGRM04",
	"FGRM04S",
	"FGRM05",
	"FGRM07",
	"FGRM08A",
	"FGRM08B",
	"FGRM08C",
	"FGRM09A",
	"FGRM09B",
	"FGRM10",
	"FGRM11",
	"FGRM12",
	"FGRM13",
	"FGRM14",
	"FGRM15",

	"ETC00", // $B%*!<%W%K%s%0(B
	"ETC16", // $B%+%l%s%@!<(B(11$B7n(B)
	"ETC17", 
	"ETC18", //       :
	"ETC19", //       :
	"ETC20",
	"ETC21", // $B%+%l%s%@!<(B(4$B7n(B)
	"ETC22", // Tactics$B%m%4(B
};
//---------------------------------------------------------------------------
int main()
{
	u8* pSrc;
	u8* pDst;
	u32 srcSize;
	u32 dstSize;

	s32 i;

	for(i=0; i<ARRAY_SIZE(FileList); i++)
	{
		printf("decode jpg ... %s\n", FileList[i]);

		srcSize = OpenBuf(FileList[i], &pSrc);
		dstSize = DecodeJpg(FileList[i], pSrc, srcSize, &pDst);

		SaveFile(FileList[i], pDst, dstSize);

		free(pSrc);
//		free(pDst); free$BI,MW$J$7(B
	}

	return 0;
}
//---------------------------------------------------------------------------
u32 OpenBuf(const char* pName, u8** pBuf)
{
	FILE* fp = fopen(pName, "rb");

	if(fp == NULL)
	{
		printf("err filename\n");
		exit(1);
	}

	fpos_t fsize;
	fseek(fp,0,SEEK_END);
	fgetpos(fp, &fsize);
	fseek(fp,0,SEEK_SET);

	*pBuf = (u8*)calloc(fsize, sizeof(u8));
	fread(*pBuf, sizeof(u8), fsize, fp);
	fclose(fp);

	return fsize;
}
//---------------------------------------------------------------------------
// jpeg$B%G!<%?$XJQ49(B
// 
// $B%*%j%8%J%k%=!<%9$O!"(B
// $B$<$($?$5$s(B<QZC05100@nifty.ne.jp>$B$N(BSusie plugin (Delphi$B$G5-=R(B)
// $BED?,$5$s(B<tajiri@wizard.elec.waseda.ac.jp> ($B>e5-%=!<%9$r(BC$B$KJQ49(B)
// $B$+$i0zMQ$7$^$7$?!#(B
// 
// $B>e5-0zMQ$K<c43$N:GE,2==hM}$r2C$($^$7$?!#(B

u32 DecodeJpg(const char* pName, u8* pSrc, u32 srcSize, u8** pDst)
{
	const char key[] = "YET11.ITaRu.MiKiPoN.ShiNoRi-"; //$B0E9f!&I|9f%-!<(B
	const int bufsize = 0x1000;
	int l = strlen(key);
	const int num = srcSize / bufsize;
	int i, j;

	// $B$3$NJQ49$G$OF~=PNO$N%5%$%:$OJQ49$7$J$$$N$G(B, $B?7$?$K%a%b%j$r3d$jEv$F$k(B
	// $BI,MW$,$J$$(B
	*pDst = pSrc;

	// $BA0CV7A$N(B++$B$,;H$($k$h$&(B, $B$"$i$+$8$a0z$$$F$*$/(B
	--pSrc;

	for(i=0; i<num; i++)
	{
		// 0x1000$B$4$H%G%3!<%I!#(B
		for(j=0; j<bufsize; j++)
		{
			*++pSrc ^= key[j % l];
		}
	}

	// $B;D$j(B
	for(j=0; j<(srcSize % bufsize); j++)
	{
		*++pSrc ^= key[j % l];
	}

	return srcSize;
}
//---------------------------------------------------------------------------
void SaveFile(const char* pName, u8* pDst, u32 dstSize)
{
	char dstName[64];
	strcpy(dstName, pName);
	strcat(dstName, ".jpg");

	FILE* out = fopen(dstName, "wb");
	if(out == NULL)
	{
		printf("err save file: %s\n", dstName);
		exit(1);
	}

	fwrite(pDst, sizeof(u8), dstSize, out);
	fclose(out);
}
