#ifndef __ONE_SNX_H__
#define __ONE_SNX_H__


#include "gba.h"


//---------------------------------------------------------------------------

// XNvgt@C̃wb_
typedef struct {
	unsigned short rootID;		// 1oCg͖Ăǂ(?)
	unsigned short reserved1;
	unsigned short numLeaf;
	unsigned short reserved2;
	unsigned long  expandSize;	// WJ̃TCY?
} ScriptFileHeader;

// XNvgt@C̃nt}
typedef struct {
	unsigned short id;
	unsigned short reserved0;
	unsigned short child0;
	unsigned short reserved1;
	unsigned short child1;
	unsigned short reserved2;
} HuffmanTree;


//---------------------------------------------------------------------------
u32  OpenBuf(const char* pName, u8** pBuf);
u32  DecodeSnx(u8* pSrc, u8** pDst);
void SaveFile(const char* pName, u8* pDst, u32 dstSize);


#endif
