/*=======================================================================
  xakane for Zaurus
  Copyright 2001, K.Takagi(Kenjo)

  filemgr.h
    A[JCuANZX
=======================================================================*/
/* ================================================================
   xakane  --- ONE ` for bright season for X ---
   (c) Copyright 2000, 2001 Nao <nao@sore.totto.to>
   All rights reserved.
================================================================ */

#ifndef _akane_filemgr_h
#define _akane_filemgr_h

extern const char* const sFileList[];

int ArcFile_Init(char* drv);
void ArcFile_Cleanup(void);
unsigned char* ArcFile_Load(char* file, int* size);
int ArcFile_GetFileNumber(char* file);
unsigned char* ArcFile_LoadScript(char* file, int* size);
unsigned char* ArcFile_LoadBMP(char* file, int* size);
unsigned char* ArcFile_LoadBG(char* file, int* size);

// XNvgt@C̃wb_
typedef struct {
	unsigned short rootID;		// 1oCg͖Ăǂ(?)
	unsigned short reserved1;
	unsigned short numLeaf;
	unsigned short reserved2;
	unsigned long  expandSize;	// WJ̃TCY?
} ScriptFileHeader;

// XNvgt@C̃nt}
typedef struct {
	unsigned short id;
	unsigned short reserved0;
	unsigned short child0;
	unsigned short reserved1;
	unsigned short child1;
	unsigned short reserved2;
} HuffmanTree;

// t@CʒũACe
typedef struct {
	unsigned int pos;
	unsigned int size;
} FATITEM;

#endif
