#ifndef __FILE_H__
#define __FILE_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define FILE_MAX_SCENE_NAME_CNT		126


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void FileInit(void);

EWRAM_CODE u8*   FileGetSnx(char* pStr);
EWRAM_CODE u8*   FileGetImg(char* pStr);
EWRAM_CODE u8*   FileGetMus(u32 num);
EWRAM_CODE u32   FileGetSize(void);
EWRAM_CODE char* FileGetSceneName(u32 num);
EWRAM_CODE void  FileCalcToupper(char* pStr);


#ifdef __cplusplus
}
#endif
#endif
