#ifndef __MANAGE_H__
#define __MANAGE_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------

enum {
	MANAGE_ACT_INIT = 0x01,
	MANAGE_ACT_SCRIPT,
};


//---------------------------------------------------------------------------

typedef struct {
	u32 act;

} ST_MANAGE;


//---------------------------------------------------------------------------
EWRAM_CODE void ManageInit(void);

EWRAM_CODE void ManageExec(void);
EWRAM_CODE void ManageExecInit(void);
EWRAM_CODE void ManageExecScript(void);


#ifdef __cplusplus
}
#endif
#endif
