#include <stdio.h>
#include <string.h>
#include "onepak.h"


//---------------------------------------------------------------------------
//$B!V(BONE$B!W$G;HMQ$5$l$F$$$k%U%!%$%kL>$H!"$=$l$KBP1~$9$k%"!<%+%$%V$N(B
// index($BG[Ns$NE:;z(B)$B$H$N(BMapping$B%F!<%V%k(B
// $B$K$c$j$s$5$s$N(Bfilelist.h$B$rMxMQ$7$F:n@.!#(B
// cf. http://members.tripod.co.jp/KanonBSD/diary/200001b.html#1103

const char* FileList[] = {
	"BG000",
	"BG010A",
	"BG010B",
	"BG010N",
	"BG010R",
	"BG020",
	"BG026",
	"BG027",
	"BG028",
	"BG030",
	"BG030B",
	"BG030N",
	"BG030NR",
	"BG030R",
	"BG030Y",
	"BG040",
	"BG040N",
	"BG040Y",
	"BG050",
	"BG050N",
	"BG060",
	"BG060N",
	"BG060R",
	"BG060Y",
	"BG070",
	"BG070N",
	"BG080",
	"BG080N",
	"BG080Y",
	"BG090",
	"BG090N",
	"BG100",
	"BG100N",
	"BG110",
	"BG110N",
	"BG120",
	"BG120A",
	"BG120N",
	"BG120Y",
	"BG130",
	"BG130A",
	"BG130N",
	"BG130R",
	"BG130Y",
	"BG140",
	"BG140N",
	"BG150",
	"BG160",
	"BG160A",
	"BG160N",
	"BG160R",
	"BG170",
	"BG170A",
	"BG170R",
	"BG170Y",
	"BG180",
	"BG180A",
	"BG180B",
	"BG190",
	"BG200",
	"BG200B",
	"BG200C",
	"BG200D",
	"BG210",
	"BG210B",
	"BG220",
	"BG220N",
	"BG220R",
	"BG220Y",
	"BG230",
	"BG230Y",
	"BG240",
	"BG240B",
	"BG250",
	"BG270",
	"BG270N",
	"BG280",
	"BG290",
	"BG300",
	"BG300Y",
	"BG310",
	"BG320",
	"BG330",
	"BG500",
	"BG501",
	"BG502",
	"BG503",
	"BG504",
	"BG505",
	"BG506",
	"BG507",
	"BG508",
	"BG510",
	"BG800",
	"BG801",
	"BG802",
	"BG803",
	"BG804",
	"BG805",
	"BG806",
	"BG807",
	"BG808",
	"BG809",
	"BG810",
	"BG811",
	"BG812",
	"BG813",
	"BG850",
	"BG851",
	"BG852",
	"BG853",
	"BG854",
	"BG855",
	"BG856",
	"BG857",
	"BG858",
	"BG859",
	"BG860",
	"BG861",
	"BG862",
	"BG863",
	"BG864",
	"BG865",
	"BG866",
	"BG867",
	"BG868",
	"BG869",
	"BG870",
	"BG871",
	"BG872",
	"BG873",
	"BG874",
	"BG875",
	"BG900",
	"FGAK01",
	"FGAK02C",
	"FGAK02D",
	"FGAK02F",
	"FGAK02G",
	"FGAK03",
	"FGAK04",
	"FGAK05A",
	"FGAK05B",
	"FGAK05C",
	"FGAK05D",
	"FGAK05E",
	"FGAK05F",
	"FGAK06",
	"FGAK07",
	"FGAK08",
	"FGAK09",
	"FGAK10",
	"FGAK11",
	"FGAK12",
	"FGAK13",
	"FGAK14",
	"FGAK15",
	"FGAK16",
	"FGMI01",
	"FGMI02",
	"FGMI03",
	"FGMI04",
	"FGMI05",
	"FGMI06",
	"FGMI07A",
	"FGMI07B",
	"FGMI07C",
	"FGMI08",
	"FGMI09",
	"FGMI10A",
	"FGMI10B",
	"FGMI11",
	"FGMI12",
	"FGMI13",
	"FGMI14A",
	"FGMI14B",
	"FGMI15",
	"FGMI16",
	"FGMS01",
	"FGMS02",
	"FGMS03",
	"FGMS04A",
	"FGMS04B",
	"FGMS05A",
	"FGMS05B",
	"FGMS06",
	"FGMS07",
	"FGMS08",
	"FGMS09",
	"FGMS10",
	"FGMS11A",
	"FGMS11B",
	"FGMS12",
	"FGMS13",
	"FGMS14",
	"FGMS15A",
	"FGMS15B",
	"FGMS16",
	"FGMS17",
	"FGMY01",
	"FGMY03A",
	"FGMY03B",
	"FGMY03C",
	"FGMY04",
	"FGMY05",
	"FGMY06",
	"FGMY07",
	"FGMY08",
	"FGMY09",
	"FGMY11",
	"FGMY12",
	"FGMY13",
	"FGMY14",
	"FGMY15A",
	"FGMY15B",
	"FGMY15C",
	"FGMZ01",
	"FGMZ02",
	"FGMZ03",
	"FGMZ04",
	"FGMZ05A",
	"FGMZ05B",
	"FGMZ06A",
	"FGMZ06B",
	"FGMZ07",
	"FGMZ08",
	"FGMZ09A",
	"FGMZ09B",
	"FGMZ10",
	"FGMZ11",
	"FGMZ12",
	"FGMZ13",
	"FGMZ14",
	"FGMZ15",
	"FGMZ16",
	"FGRM01",
	"FGRM02A",
	"FGRM02B",
	"FGRM02E",
	"FGRM02G",
	"FGRM02GN",
	"FGRM02H",
	"FGRM02V",
	"FGRM03A",
	"FGRM03B",
	"FGRM04",
	"FGRM04S",
	"FGRM05",
	"FGRM07",
	"FGRM08A",
	"FGRM08B",
	"FGRM08C",
	"FGRM09A",
	"FGRM09B",
	"FGRM10",
	"FGRM11",
	"FGRM12",
	"FGRM13",
	"FGRM14",
	"FGRM15",
	// index = 260
	"ETC00", // $B%*!<%W%K%s%0(B
	"ETC01", // $B%*!<%W%K%s%0(B($BA*Br;h(B)
	"ETC02", // $B%9%Z%7%c%k%a%K%e!<(B
	"ETC03", // $B%9%Z%7%c%k%a%K%e!<(B($BA*Br;h(B)
	"ETC04", // $B%9%?%C%U$NL>A0$,=q$$$F$"$k$s$@$,!D!D(B
	"ETC05", // $B%9%?%C%U$NL>A0$,=q$$$F$"$k$s$@$,!D!D(B($BA*Br;h(B)
	"ETC06", // CG$B4U>^%b!<%I(B
	"ETC07", // CG$B4U>^%b!<%I(B($BA*Br;h(B)
	"ETC08", // CG$B4U>^%b!<%I(B($BD9?9(B)
	"ETC09", // CG$B4U>^%b!<%I(B($B<7@%(B)
	"ETC10", // CG$B4U>^%b!<%I(B($BKz(B)
	"ETC11", // CG$B4U>^%b!<%I(B($B_:(B)
	"ETC12", // CG$B4U>^%b!<%I(B($B$_$5$-@hGZ(B)
	"ETC13", // CG$B4U>^%b!<%I(B($B0+(B)
	"ETC14", // $B%5%&%s%I%b!<%I(B
	"ETC15", // $B%5%&%s%I%b!<%I(B($BA*Br;h(B)
	"ETC16", // $B%+%l%s%@!<(B(11$B7n(B)
	"ETC17", 
	"ETC18", //       :
	"ETC19", //       :
	"ETC20",
	"ETC21", // $B%+%l%s%@!<(B(4$B7n(B)
	"ETC22", // Tactics$B%m%4(B
	"ETC23", // $B%"%K%a!<%7%g%sMQ2hA|(B($BHs05=L(BBMP)
	"CGAK10",
	"CGAK11",
	"CGAK12",
	"CGAK13",
	"CGAK14",
	"CGAK20",
	"CGAK21",
	"CGAK22",
	"CGAK23",
	"CGAK24",
	"CGAK25",
	"CGAK22N",
	"CGAK23N",
	"CGAK30",
	"CGAK31",
	"CGAK32",
	"CGAK30N",
	"CGAK32N",
	"CGAK40",
	"CGAK41",
	"CGAK42",
	"CGAK43",
	"CGAK44",
	"CGAK45",
	"CGAK50",
	"CGAK51",
	"CGAK60",
	"CGAK61",
	"CGAK62",
	"CGMI10",
	"CGMI11",
	"CGMI11S",
	"CGMI20",
	"CGMI21",
	"CGMI22",
	"CGMI23",
	"CGMI24",
	"CGMI25",
	"CGMI26",
	"CGMI20N",
	"CGMI21N",
	"CGMI23N",
	"CGMI24N",
	"CGMI25N",
	"CGMI20S",
	"CGMI21S",
	"CGMI24S",
	"CGMI30",
	"CGMI31",
	"CGMI32",
	"CGMI32N",
	"CGMI40",
	"CGMI41",
	"CGMI42",
	"CGMI43",
	"CGMI44",
	"CGMI41N",
	"CGMI43N",
	"CGMI40S",
	"CGMI43S",
	"CGMI51",
	"CGMI50N",
	"CGMI60",
	"CGMI61",
	"CGMI62",
	"CGMI63",
	"CGMI60N",
	"CGMI62N",
	"CGMI63N",
	"CGMI61S",
	"CGMK10",
	"CGMK11",
	"CGMS10",
	"CGMS12",
	"CGMS13",
	"CGMS14",
	"CGMS10N",
	"CGMS12N",
	"CGMS13N",
	"CGMS14N",
	"CGMS10S",
	"CGMS12S",
	"CGMS21",
	"CGMS21N",
	"CGMS31",
	"CGMS40",
	"CGMS41",
	"CGMS42",
	"CGMS40N",
	"CGMS40S",
	"CGMS41S",
	"CGMS42S",
	"CGMS50",
	"CGMS51",
	"CGMS52",
	"CGMS53",
	"CGMS54",
	"CGMS55",
	"CGMS50N",
	"CGMS51N",
	"CGMS52N",
	"CGMS55N",
	"CGMS50S",
	"CGMS51S",
	"CGMS52S",
	"CGMS60",
	"CGMS60N",
	"CGMS60S",
	"CGMY10",
	"CGMY11",
	"CGMY12",
	"CGMY13",
	"CGMY14",
	"CGMY10N",
	"CGMY10C",
	"CGMY11C",
	"CGMY12C",
	"CGMY13C",
	"CGMY14C",
	"CGMY11D",
	"CGMY14D",
	"CGMY11DN",
	"CGMY14DN",
	"CGMY20",
	"CGMY20C",
	"CGMY20D",
	"CGMY30",
	"CGMY31",
	"CGMY32",
	"CGMY33",
	"CGMY34",
	"CGMY31N",
	"CGMY30C",
	"CGMY31C",
	"CGMY32C",
	"CGMY33C",
	"CGMY34C",
	"CGMY30D",
	"CGMY31D",
	"CGMY40",
	"CGMY41",
	"CGMY50",
	"CGMZ10",
	"CGMZ20",
	"CGMZ21",
	"CGMZ20N",
	"CGMZ30",
	"CGMZ31",
	"CGMZ32",
	"CGMZ33",
	"CGMZ34",
	"CGMZ33N",
	"CGMZ40",
	"CGMZ41",
	"CGMZ42",
	"CGMZ43",
	"CGMZ44",
	"CGMZ45",
	"CGMZ46",
	"CGMZ40N",
	"CGMZ41N",
	"CGMZ42N",
	"CGMZ43N",
	"CGMZ50",
	"CGMZ51",
	"CGRM10",
	"CGRM11",
	"CGRM12",
	"CGRM13",
	"CGRM14",
	"CGRM15",
	"CGRM10N",
	"CGRM11N",
	"CGRM14N",
	"CGRM15N",
	"CGRM20",
	"CGRM40",
	"CGRM43",
	"CGRM43N",
	"CGRM50",
	"CGRM51",
	"CGRM50N",
	"CGRM60",
	"CGSK10",
	"CGSK11",
	"CGSK12",
	"CGSK13",
	"CGSK14",
	"CGSK15",
	"CGSK20",
	"CGSK21",
	"CGSK22",
	"CGSK23",
	"CGSK24",
	"CGSK25",
	"CGSK26",
	"CGSM10",
	"CGSY10",
	"CGSY11",
	"CGSY21",
	"CGWA10",
	"CGWA11",
	"CGWA12",
	"CGWA13",
	"CGWA20",
	"CGWA21",
	"CGWA22",
	"CGWA23",
	// index = 492
	"INIT",
	"AK21",
	"AK22",
	"AK24",
	"AK25",
	"AK26",
	"AK27",
	"AK27_B",
	"AK_END",
	"AKANEN",
	"AKMI21",
	"AKMI22",
	"AP00",
	"AP01",
	"ASA",
	"DS01",
	"DS02",
	"DS03",
	"DS04",
	"DS05",
	"DS07",
	"DS08",
	"DS09",
	"DS10",
	"DS10_A",
	"DS11",
	"DS14",
	"DS15",
	"DS16",
	"DS17",
	"DS18",
	"DS19",
	"DS22",
	"DS24",
	"DS25",
	"HIKAMI",
	"MI_A",
	"MI21",
	"MI22",
	"MI24",
	"MI25",
	"MI26",
	"MIMS21",
	"MISAO",
	"MS_B",
	"MS21",
	"MS22",
	"MS24",
	"MS25",
	"MS26",
	"MS27",
	"MS28",
	"MY21",
	"MY22",
	"MY24",
	"MY25",
	"MZ19",
	"MZ21",
	"MZ22",
	"MZ24",
	"MZ25~",
	"MZ26",
	"NV30",
	"RM14",
	"RM15",
	"RM16",
	"RM17",
	"RM18",
	"RM19",
	"RM21",
	"RM22",
	"RM24",
	"RM25",
	"RM26",
	"RMM1",
	"RMM2",
	"RMM3",
	"WORLD",
	"DEBUG",
};

//---------------------------------------------------------------------------
int main()
{
	FILE* in = fopen("DAT00.org", "rb");

	if(in == NULL)
	{
		printf("can't open archive file\n");
		return 1;
	}


	ST_ARC_HEADER arcHeader;

	fread(&arcHeader, sizeof(ST_ARC_HEADER), 1, in);

	if(strncmp(arcHeader.magic, "YS ver1.00", sizeof("YS ver1.00")-1) != 0)
	{
		printf("err magic\n");
		return 1;
	}

	if(arcHeader.num != ARRAY_SIZE(FileList))
	{
		printf("err num\n");
		return 1;
	}


	ST_ARC_ENTRY arcEntry;
	s32 i;

	for(i=0; i<arcHeader.num; i++)
	{
		// $B%j%9%H$rCj=P$7$^$9(B
		fseek(in, sizeof(ST_ARC_HEADER) + sizeof(ST_ARC_ENTRY) * i, SEEK_SET);
		fread(&arcEntry, sizeof(ST_ARC_ENTRY), 1, in);
		printf("%-9s %-d\n", FileList[i], arcEntry.size);

		// $B%P%C%U%!$K%G!<%?$r%3%T!<$7$^$9(B
		u8* buf = malloc(arcEntry.size);
		if(buf == NULL)
		{
			printf("err malloc\n");
			return 1;
		}

		fseek(in, arcEntry.offset, SEEK_SET);
		fread(buf, 1, arcEntry.size, in);

		// $B%U%!%$%k$KJ]B8$7$^$9(B
		FILE* out = fopen(FileList[i], "wb");
		if(out == NULL)
		{
			printf("err save file: %s\n", FileList[i]);
			return 1;
		}

		fwrite(buf, sizeof(u8), arcEntry.size, out);
		fclose(out);
		free(buf);
	}

	fclose(in);
	return 0;
}
