#contoroldef=Crimson.ctl
#resourcefile=WLK1FM00
#label=saveload
#part={
#partname=saveload
#partfile=saveload.ptr
#@x=0
#@y=0
#@width=10
#@height=10
#callback FormConstruct 0 
#callback FormRedisp 25 
void saveloadFormRedisp(APLFORMPTR AplForm, WINDOWHD WnHandle)
{
	POINT where;
	COLOR fg, bg;
	char str[64];

	if ( AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadFlag == SAVELOAD_SAVE ) {
		sprintf(str, "Z[uf[^I");
	} else {
		sprintf(str, "[hf[^I");
	} 

	/* tH[Ŝ\ */
	FormDefRedisp( AplForm, WnHandle );

	/* `W̐ݒ */
	where.x = 24 * 4;
	where.y = 1  * 4;

	/* `F̐ݒ */
	SetColorV( &fg, BLACK );
	SetColorV( &bg, BLACK );

	DrawStr( WnHandle, &where, &fg, &bg, FSET + QP48_CHR, str, 0, NULL, DS_HOLLOWED );
}
#callback FormSetUp 17 
void saveloadFormSetUp(APLFORMPTR AplForm, MESSAGE* Message)
{
	MESSAGE	msg;

	SetCtrlProperty( SaveLoadList, ALL_DATA_NO_PID, usValue, MAXSAVEFILE, AplForm->Control );

	msg.CommonMsg.MessageID = ToolInitID;
	ControlCall( SaveLoadList, AplForm->Control, &msg );

	SetCtrlProperty( SaveLoadList, DISP_OFFSET_PID, usValue, 0, AplForm->Control );

	SetCtrlProperty( SaveLoadList, LIST_CALL_BACK_WORK_PID, pValue, (PTR)AplForm, AplForm->Control );

	msg.CommonMsg.MessageID = ListActiveNodispID;
	msg.ListActiveNodisp.TargetID = 0;
	ControlCall( SaveLoadList, AplForm->Control, &msg );
}
#callback FormEnd 0 
#callback FormDeActivate 0 
#callback FormActivate 0 
#callback FormEventFilter 0 
#callback FormMenuAtrSet 0 
#callback FormMenuSelect 0 
#callback FormKeyExec 45 
void saveloadFormKeyExec(APLFORMPTR AplForm, MESSAGE* Message, const MESSAGE* KeyMsg)
{
	MESSAGE msg;
	USHORT	no;

	GetCtrlProperty( SaveLoadList, LIST_ACTIVE_ITEM_PID, usValue, no, AplForm->Control, USHORT );

	switch (KeyMsg->CommonMsg.MessageID)
	{
		case KeyDownID:
			switch(KeyMsg->KeyDown.KeyCode)
			{
				case KC_CURSOR_UP:
					if ( no>1 ) {
						msg.CommonMsg.MessageID = ListActiveRedispID;
						msg.ListActiveRedisp.TargetID = no-2;
						ControlCall( SaveLoadList, AplForm->Control, &msg );
					}
					break;
				case KC_CURSOR_DOWN:
					if ( no<MAXSAVEFILE ) {
						msg.CommonMsg.MessageID = ListActiveRedispID;
						msg.ListActiveRedisp.TargetID = no;
						ControlCall( SaveLoadList, AplForm->Control, &msg );
					}
					break;
				case KC_DECIDE:
				case KC_CURSOR_RIGHT:
					AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadNo = no-1;
					AplForm->IsExit = true;
					break;
					ReleasePenKey( DELETE_PEN_UP );
					DeleteEventMsg(KeyDownID);
				case KC_BACK:
					AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadNo = -1;
					AplForm->IsExit = true;
					ReleasePenKey( DELETE_PEN_UP );
					DeleteEventMsg(KeyDownID);
					break;
				default:
					break;
			}
			break;
	}
}
#callback FormError 0 
#callback FormOtherEvent 10 
void saveloadFormOtherEvent(APLFORMPTR AplForm, MESSAGE* Message)
{
	switch ( Message->CommonMsg.MessageID ) {
		case AppliActivateID:
			if ( !Message->AppliActivate.IsActivate ) {
				AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadNo = -1;
				AplForm->IsExit = true;
			}
	}
}
#callback FormMenuFilter 0 
}
#part={
#partname=SaveLoadList
#partfile=SaveLoadList.ptr
#@x=-32768
#@y=-32768
#@width=0
#@height=0
#eventproc ListSelectID 15 
void SaveLoadListListSelect(APLFORMPTR AplForm, MESSAGE* Message, const MESSAGE* ListMsg)
{
	MESSAGE	msg;
	USHORT	no;

	GetCtrlProperty( SaveLoadList, LIST_ACTIVE_ITEM_PID, usValue, no, AplForm->Control, USHORT );
	if ( no==(ListMsg->ListSelect.ItemID+1) ) {
		AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadNo = ListMsg->ListSelect.ItemID;
		AplForm->IsExit = true;
	} else {
		msg.CommonMsg.MessageID = ListActiveRedispID;
		msg.ListActiveRedisp.TargetID = ListMsg->ListSelect.ItemID;
		ControlCall( SaveLoadList, AplForm->Control, &msg );
	}
}
#eventproc ToolDragStartID 0 
#eventproc BarButtonStillSelectID 0 
#eventproc BarButtonSelectID 0 
#eventproc BarSliderPressID 0 
#eventproc BarButtonPressID 0 
#eventproc ListChangeActiveID 0 
#eventproc BarListChangeActiveID 0 
#eventproc ListPressID 0 
#eventproc ListChangePressID 0 
#subpart={
#partname=LIST
#partfile=""
#@x=0
#@y=16
#@width=230
#@height=171
#eventproc ListPressID 0 
#eventproc ListChangePressID 0 
#eventproc ListPressAreaID 0 
#eventproc ListSelectID 0 
#eventproc ListSelectAreaID 0 
#eventproc ListChangeActiveID 0 
#eventproc ListScrollUpID 0 
#eventproc ListScrollDownID 0 
#eventproc ToolDragStartID 0 
#callback LIST_CALL_BACK_PID 19 
void LISTListCB(APLFORMPTR AplForm, unsigned short Data, unsigned short Line,
           short X1, short Y1, short X2, short Y2)
{
	POINT pt;
	COLOR fg, bg;
	char buf[64];

	if( Data>=MAXSAVEFILE ) {
		/* f[^̖sւ̃R[obN */
		return;
	}

	/* Z[u^Cg */
	pt.x = X1 + 2 * 4;
	pt.y = Y1 + 2 * 4;
	SetColorV( &fg, BLACK );
	Sys_GetSaveDataTitle(Data, buf);
	DrawStr( AplForm->FormWnHandle, &pt, &fg, &bg, FSET+QP48_CHR, buf, 0, NULL, DS_NORMAL );
}
}
}
#part={
#partname=CloseButton
#partfile=CloaseButton.ptr
#@x=0
#@y=0
#@width=16
#@height=16
#eventproc ButtonSelectID 5 
void CloseButtonBtnSelect(APLFORMPTR AplForm, MESSAGE* Message, const MESSAGE* BtnMsg)
{
	AkaneWork((APLFORMPTR)AplForm->AppliWorkPtr)->SaveLoadNo = -1;
	AplForm->IsExit = true;
}
#eventproc ButtonPressID 0 
#eventproc ButtonPressStartID 0 
#eventproc ButtonStillSelectID 0 
}
